#!/bin/csh -f 
set newlog = new-runs
set oldlog = ../sample-runs
set bin = ../bin
unset noclobber

@ diffs = 0

set a = fit-move-comp
echo Running $a ...
($bin/$a.exe -Moving 5pti_rot.pdb -Fixed 5pti.pdb \
        -FitTR -SelectAll -CompareCoordinates -SimpleDumpRT \
        > $newlog/$a.out  ) >& $newlog/$a.err
echo ... exits with status $status

set a = calc-surface 
echo Running $a ...
($bin/$a.exe -i 5pti.pdb > $newlog/$a.out) >& $newlog/$a.err
echo ... exits with status $status

set a = calc-volume
echo Running $a ...
($bin/$a.exe -i 5pti.pdb > $newlog/$a.out) >& $newlog/$a.err
echo ... exits with status $status

set a = show-2rad-refV
echo Running $a ...
($bin/$a.exe -i 5pti.pdb > $newlog/$a.out) >& $newlog/$a.err
echo ... exits with status $status

set a = show-atom-types
echo Running $a ...
($bin/$a.exe -i 5pti.pdb > $newlog/$a.out) >& $newlog/$a.err
echo ... exits with status $status

set a = full-dump-polyhedra
echo Running $a ...
($bin/$a.exe  -i 5pti.pdb | grep "FullDumpPoly(): END polyhedron" > $newlog/$a.out) >& $newlog/$a.err
echo ... exits with status $status

set a = dump-polyhedra
echo Running $a ...
($bin/$a.exe -i 5pti.pdb | grep ATOM > $newlog/$a.out) >& $newlog/$a.err
echo ... exits with status $status

rm check-progs.result >& /dev/null

foreach a (calc-surface calc-volume \
           show-2rad-refV show-atom-types \
           full-dump-polyhedra dump-polyhedra fit-move-comp)

echo Checking output of $a ...

echo diff $newlog/$a.out $oldlog/$a.out > $a.diff 
diff $newlog/$a.out $oldlog/$a.out >> $a.diff

if ($status == 0) then
   echo The program $a.exe checks out >> check-progs.result
   rm $a.diff	
else
   echo The program $a.exe has problems >> check-progs.result
   echo -- check out $a.diff, the output, and the log files >> check-progs.result
   @ diffs++
endif

end # foreach

cat check-progs.result

if ($diffs == 0) then
   echo \* Everything checks out
   exit 0
else 
   echo \* All programs do not check out
   exit 1
endif







