#!/usr/bin/perl -w
use Getopt::Std;
use Text::Tabs;

getopt("ios", \%args);

#Set input variables
 if(!$args{'i'} || !$args{'s'} || !$args{'o'}) { die; }
 $in = $args{'i'};
 $sym = $args{'s'};
 $out = $args{'o'};

print "\n\nNAM pdb file: $in\n";
print "SYMM input file: $sym\n";
system("wc -l $sym");

open(OUT, "> $out")
   or die "Couldn't open $out for writing: $!\n";

#Set input variables
print "Writing to: $out\n\n";

#Open Files

print STDERR "Parsing $in file..."; 
open(IN, "< $in")
   or die "Couldn't open $in for reading: $!\n";

$accept = 0;
#number_ resnum  chain   resname atname  typenum typenam covrad  vdwrad  surface volume  refvol  packeff goodbad
#  80000      26 O         GLU     C        1    C3H0s     0.770   1.610   2.783   9.348   1.610   5.806 [OK]
#  98573    7898 .         HOH     O       20    O2H2u     0.660   1.460   2.337  23.477   1.460  16.080 [OK]
#00000000001111111111222222222233333333334444444444555555555566666666667777777777888888888899999999990000000
#01234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456


while(defined($line = <IN>)) {
   if(substr($line,0,4) eq "ATOM") {
     $atom = substr($line,6,5);
     $atom =~ s/\s+$//; $atom =~ s/^\s+//;
     $resnum = substr($line,22,4);
     $resnum =~ s/\s+$//; $resnum =~ s/^\s+//;
     $resnam = substr($line,17,3);
     $resnam =~ s/\s+$//; $resnam =~ s/^\s+//;
     $atnam = substr($line,12,4);
     $atnam =~ s/\s+$//; $atnam =~ s/^\s+//;
     $hash = $atom."-".$resnum."-".$resnam."-".$atnam;              #is hash good enough?
     $exists{$hash}=1;
     $accept++;
   }
}
print "done (found $accept entries)\n\n";
close(IN);

print STDERR "Chopping $sym file and Writing to $out file...\n";
open(SYM, "< $sym")
   or die "Couldn't open $sym for reading: $!\n";

$count = 0;
$carrot = int($accept/50);
print STDERR "|----+----+----+----+----|----+----+----+----+----|\n";
while(defined($line = <SYM>)) {
#   expand($line);         #very slow !!!
   if(substr($line,0,4) ne "numb") {
      @chunks = split(' ',$line);
      $atom = $chunks[0];
      $atom =~ s/\s+$//; $atom =~ s/^\s+//;
      $resnum = $chunks[1];
      $resnum =~ s/\s+$//; $resnum =~ s/^\s+//;
      $resnam = $chunks[3];
      $resnam =~ s/\s+$//; $resnam =~ s/^\s+//;
      $atnam = $chunks[4];
      $atnam =~ s/\s+$//; $atnam =~ s/^\s+//;
      $hash = $atom."-".$resnum."-".$resnam."-".$atnam;            #is hash good enough?
      if($exists{$hash}) { 
         print OUT $line; 
         $count++;
         if($count % $carrot == 0) { print STDERR "^"; } 
         if($exists{$hash} > 1) {
            print STDERR "\nHash collision... $hash"; 
         }
         $exists{$hash}++;
      }
   }
}
close(SYM);
print STDERR "\ndone (found $count of original $accept entries)\n\n";
close(OUT);
