#ifndef __MAKENEWATOM_H__
#define __MAKENEWATOM_H__

#include "pdb.h"

#ifdef __cplusplus
extern "C" {
#endif

#include "pdb.h"

/*
   Give the following routine something like:
   string =  "ATOM   3499  O   HOH   723      62.269   5.771  23.986  1.00 30.84    " ;
   n = 100 ;
*/
file_records *ConstructNDummyAtoms(char * string, int n);

/* Internal */
atom_record * MakeNewAtom(char * string);

/*
   This modifies the residue connectivity in f1 and f2.
*/
file_records *JoinFileRecords_1then2 (file_records *f1,file_records *f2);

/*
   This deallocates file_record f 
   without freeing the atoms pointed to by f->atoms[ii].
*/
void FreeFileRecordsWithOutFreeingAtoms(file_records *f);

#ifdef OFF 
/* These are private for now . */ 
atom_record * RadFileStringToNewAtom(char * string);
file_records *ReadRadFile(FILE * ff, int format);
#endif
file_records *OpenReadRadFile(char * name,int format);

file_records *MoveSelectedToDerivedFileRecord(file_records *f, int flag);
file_records *NewFileRecWithOutWaterOrSymChain(file_records *f);
file_records *NewFileRecWithOutWater(file_records *f);



#ifdef __cplusplus
}
#endif

#endif /* !__MAKENEWATOM_H__ */

