#ifndef __MODIFIEDVOLUME_H__
#define __MODIFIEDVOLUME_H__

#include "pdb.h"
#include "NNvolume.h"
#include "VectorList.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef  void (*CalcVHookFcnType)(atom_record *atom,neibour_descr *neibours,int neibour_count);

extern CalcVHookFcnType CalcVHookFcn ;




/* Called from N_calculate_volume() */
void SaveAtomVertices(int i, atom_record * a, vertex *v1, vertex *v2)
;


void N_Calculate_Volumes(file_records *file, int the_method, 
 double volume_max_dist, double distance_check)
;


/* [ 1b ] called 1st :
   Sets up the neighbor calculation and calculates the volume of a whole file . 
   Calls LoopOverNeighbors() & SaveAtomVertices() .
*/
void NN_Calculate_Volumes 
(file_records *file, int TheMethod, double VolMaxDist, double DistCheck)
;

/* Called from N_calculate_atom_volume(). Similar to N_calculate_vertices(). */
void LoopOverNeighbors(atom_record *atom, neibour_descr *n_atoms,int n_count)
;
  
void Simple_Calculate_Volumes 
(file_records *file, int TheMethod, double VolMaxDist, double DistCheck)
;

#ifdef __cplusplus
}
#endif

#endif /* !__MODIFIEDVOLUME_H__ */
















