# include "pdb.h"

# ifdef COMMENT

/* These are in pdb.h: */

#define SWITCH_ON(atom,flag) atom->flags |= flag
#define SWITCH_OFF(atom,flag) atom->flags &= ~flag

/* Values for the flag field in atom_record    */

#define IGNORE_ATOM 1
#define DONT_CALCULATE_ATOM 2
#define MODIFIED_ATOM 4
#define SULPHUR_BRIDGE 8
#define MAIN_CHAIN_ATOM 16
#define REJECTED_ATOM 32
#define BURIED_WATER 64
/* New flag definitions from MBG */
#define FLAG_1_DESELECT IGNORE_ATOM 
#define FLAG_2_DESELECT DONT_CALCULATE_ATOM 

/* These are in macros.h: */

#define SELECTED_ATOM_P(atom) !(atom->flags & (DONT_CALCULATE_ATOM | IGNORE_ATOM))
#define NOT_SELECTED_ATOM_P(atom) atom->flags & (DONT_CALCULATE_ATOM | IGNORE_ATOM)

# endif

#define IS_SELECTED_WRT(atom,flag) (!(atom->flags & (flag)))

void PrintAtomFlags(atom_record * a) ;
void FlagOnForWaters(file_records * f,int flag) ;
void FlagOnForHydrogens(file_records * f,int flag) ;

